default:
  image: maven:3.9.0-amazoncorretto-17
  tags:
    - docker

stages:
  - build
  - test
  - publish

cache: &global_cache
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - ".m2/repository/"
      - "*/target/*"
      - "target/*"
    policy: pull-push

build:
  stage: build
  script:
    - mvn clean compile
  cache:
    <<: *global_cache
    policy: push

test-unit:
  stage: test
  script:
    - mvn test -Pcoverage
  cache:
    <<: *global_cache
    policy: pull
  artifacts:
    when: always
    reports:
      junit:
        - "target/surefire-reports/TEST-*.xml"
        - "*/target/surefire-reports/TEST-*.xml"

test-integration:
  stage: test
  script:
    - mvn verify -Pcoverage
  cache:
    <<: *global_cache
    policy: pull
  artifacts:
    when: always
    reports:
      junit:
        - "*/target/failsafe-reports/TEST-*.xml"
        - "target/failsafe-reports/TEST-*.xml"